/*
 *  ORFA -- Open Robotics Firmware Architecture
 *
 *  Copyright (c) 2009 Vladimir Ermakov, Andrey Demenev
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in
 *  all copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 *  THE SOFTWARE.
 *****************************************************************************/

#include <stdint.h>
#include <stdio.h>

#include "serialgate.h"
#include "common.h"
#include "i2c.h"
#include "lib/cbuf.h"
#include "hal/serial.h"
#include "parser.h"
//#include "command.h"

//! command buffer
static cbf_t cmd_buf;

void serialgate_init(void)
{

	cbf_init(&cmd_buf);

	#ifdef HAL_HAVE_SERIAL_FILE_DEVICE
	serial_init(BAUD);
	stdin = stdout = stderr = &serial_fdev;
	#endif

	i2c_init();

	parser_init();
}

void serialgate_supertask(void)
{
	if(serial_isempty())
		return;

	uint8_t c = getchar();

	parse_cmd(c, &cmd_buf);

}

